using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace ExampleGrid
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            gridGroupingControl1.TableDescriptor.Columns.Add("Country", "Country");
            gridGroupingControl1.TableDescriptor.Columns.Add("CurrencyID", "CurrencyID");
        }

        DataTable currency;
        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable country = new DataTable();
            country.Columns.Add("Country", typeof(string));
            country.Columns.Add("CurrencyID", typeof(Int32));
            DataRow rw = country.NewRow();
            rw["Country"] = "USA";
            rw["CurrencyID"] = 1;
            country.Rows.Add(rw);

            rw = country.NewRow();
            rw["Country"] = "France";
            rw["CurrencyID"] = 2;
            country.Rows.Add(rw);

            currency = new DataTable();
            currency.Columns.Add("CurrencyID", typeof(Int32));
            currency.Columns.Add("Currency", typeof(string));

            rw = currency.NewRow();
            rw["Currency"] = "Dollar";
            rw["CurrencyID"] = 1;
            currency.Rows.Add(rw);

            rw = currency.NewRow();
            rw["Currency"] = "Euro";
            rw["CurrencyID"] = 2;
            currency.Rows.Add(rw);

            gridGroupingControl1.DataSource = country;
            gridGroupingControl1.TableDescriptor.Columns["CurrencyID"].Appearance.AnyRecordFieldCell.CellType = "ComboBox";
            gridGroupingControl1.TableDescriptor.Columns["CurrencyID"].Appearance.AnyRecordFieldCell.DisplayMember = "Currency";
            gridGroupingControl1.TableDescriptor.Columns["CurrencyID"].Appearance.AnyRecordFieldCell.ValueMember = "CurrencyID";
            gridGroupingControl1.TableDescriptor.Columns["CurrencyID"].Appearance.AnyRecordFieldCell.DataSource = currency;
            gridGroupingControl1.TableDescriptor.Columns["CurrencyID"].Appearance.AnyRecordFieldCell.DropDownStyle = GridDropDownStyle.AutoComplete;

            gridGroupingControl1.TableDescriptor.TopLevelGroupOptions.ShowFilterBar = true;
            gridGroupingControl1.TableDescriptor.Columns["Country"].AllowFilter = true;
            gridGroupingControl1.TableDescriptor.Columns["Country"].Appearance.FilterBarCell.CellType = "TextBox";  
            gridGroupingControl1.TableDescriptor.Columns["CurrencyID"].AllowFilter = true;

            gridGroupingControl1.TableControlCurrentCellShowingDropDown += new GridTableControlCurrentCellShowingDropDownEventHandler(gridGroupingControl1_TableControlCurrentCellShowingDropDown);

            gridGroupingControl1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);
            gridGroupingControl1.TableControlCurrentCellKeyPress += new GridTableControlKeyPressEventHandler(gridGroupingControl1_TableControlCurrentCellKeyPress);
        }

        void gridGroupingControl1_TableControlCurrentCellKeyPress(object sender, GridTableControlKeyPressEventArgs e)
        {
            RecordFilterDe
            this.gridGroupingControl1.TableDescriptor.RecordFilters.Add();     
        }

        void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            e.Style.DropDownStyle = GridDropDownStyle.Editable;
            e.Style.ReadOnly = false; 
        }

        void gridGroupingControl1_TableControlCurrentCellShowingDropDown(object sender, GridTableControlCurrentCellShowingDropDownEventArgs e)
        {
            GridTableFilterBarCellRenderer cr = e.TableControl.CurrentCell.Renderer  as GridTableFilterBarCellRenderer;
            if (cr != null )
            {
                if (e.TableControl.TableDescriptor.VisibleColumns[cr.ColIndex - 1].Name == "CurrencyID")
                {
                    cr.ListBoxPart.DrawMode = DrawMode.OwnerDrawVariable;
                    cr.ListBoxPart.DrawItem += new DrawItemEventHandler(ListBoxPart_DrawItem);
                }
                else
                    cr.ListBoxPart.DrawMode = DrawMode.Normal;
                   
                
            }
        }
        int savedIndex = -1;
        string SelectedText = string.Empty;
        private void ListBoxPart_DrawItem(object sender, DrawItemEventArgs e)
        {
            //Declare the SavedIndex as the Class Member.....
           
            
            ListBox list = sender as ListBox;
            StringFormat format = new StringFormat();
            format.LineAlignment = StringAlignment.Center;
            format.Alignment = StringAlignment.Center;

            RectangleF rect = new RectangleF(e.Bounds.X, e.Bounds.Y, e.Bounds.Width, e.Bounds.Height);

            ///// dText is the drawing text of the DropDown listBox
            //// dText is the DisplayText of the  DropDown listBox
            //// you can assign any of the text to dText here
            ////--------------------------------------------------------------------------------------------------------////
            string dText = list.Items[e.Index].ToString();
            if (e.Index > 2)
                dText = currency.Rows[e.Index - 3]["Currency"].ToString();
            ////--------------------------------------------------------------------------------------------------------////

            if (list.SelectedIndex == e.Index)
            {
                if (savedIndex != -1 && savedIndex != list.SelectedIndex)
                    list.Invalidate(list.GetItemRectangle(savedIndex));
                savedIndex = list.SelectedIndex;
                e.Graphics.FillRectangle(Brushes.Gold, e.Bounds);
                e.Graphics.DrawString(dText, list.Font, new SolidBrush(list.BackColor), rect, format);
                SelectedText = dText;
            }
            else
            {
                e.Graphics.FillRectangle(Brushes.LightGoldenrodYellow, e.Bounds);
                e.Graphics.DrawString(dText, list.Font, new SolidBrush(list.ForeColor), rect, format);
            }
        }
    }
}